-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_alllayers"

-- **************************************************
-- General information about this script
-- **************************************************

DS_alllayers = {}

function DS_alllayers:Name()
	return "Go through all layers"
end

function DS_alllayers:Version()
	return "0.1"
end

function DS_alllayers:Description()
	return "Go through all layers"
end

function DS_alllayers:Creator()
	return "dauid.com"
end

function DS_alllayers:UILabel()
	return"Go through all layers"
end

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_alllayers:display_layer_flags(moho, layer, top)

    local i
    local num_layers

    if not top then
        if layer.SecondarySelection ~= nil then
            -- Display selected flag
            if layer.RT_Selected == true then
	        print(layer:Name()..'.RT_Selected=true')
	    elseif layer.RT_Selected == false then
	        print(layer:Name()..'.RT_Selected=false')
	    else
	        print(layer:Name()..'.RT_Selected=nil')
	    end
        else
            -- Set all RT_Selected flags, except for current layer, to false for ver 5.6
            layer.RT_Selected = false
        end
        -- Display visible flag
        if layer.RT_Visible == true then
	    print(layer:Name()..'.RT_Visible=true')
	elseif layer.RT_Visible == false then
	    print(layer:Name()..'.layer.RT_Visible=false')
	elseif layer.RT_Visible == nil then
	    print(layer:Name()..'.layer.RT_Visible=nil')
	end
    end

    if layer.CountLayers ~= nil then
        num_layers = layer:CountLayers()
    elseif layer:IsGroupType() then
        num_layers = moho:LayerAsGroup(layer):CountLayers()
    else
        num_layers = 0
    end

    for i = 0, num_layers-1 do
        self:display_layer_flags(moho, layer:Layer(i), false)
    end
    
end

function DS_alllayers:goThrough(moho, layer, nr)
	--
	
	moho:SetSelLayer(layer)
	if ((layer:LayerType() == MOHO.LT_GROUP) or (layer:LayerType() == MOHO.LT_SWITCH) or (layer:LayerType() == MOHO.LT_BONE)) then		
		print("Group "..nr .." - "..layer:Name())
		local layer = moho:LayerAsGroup(layer)
		for i= 0, layer:CountLayers()-1 do
		self:goThrough(moho, layer:Layer(i), i)
		end
	else
		print("      "..nr .." - "..layer:Name())
	end
	
end

function DS_alllayers:Run(moho)    
	local numlayers = moho.document:CountLayers() --Do top layers
		for i = 0, numlayers - 1 do
			moho:SetSelLayer(moho.document:Layer(i))
			local layer = moho.document:Layer(i)
			self:goThrough(moho, layer, i)
		end
end
