-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_bone_time"

-- **************************************************
-- General information about this script
-- **************************************************

DS_bone_time = {}


function DS_bone_time:Name()
	return "Bone Time Machine"
end

function DS_bone_time:Version()
	return "1.0"
end


function DS_bone_time:Description()
	return "Move mouse horizontally to get value. Hold shift to change selection speed. Holding ALT will give you select bone functionality."
end


function DS_bone_time:Creator()
	return "dauid.com"
end

function DS_bone_time:UILabel()
	return "Bone Time Machine"
end

function DS_bone_time:LoadPrefs(prefs)
	self.doRot = prefs:GetBool("DS_bone_time.doRot", true)
	self.doPos = prefs:GetBool("DS_bone_time.doPos", true)
	self.doScale = prefs:GetBool("DS_bone_time.doScale", true)
end

function DS_bone_time:SavePrefs(prefs)
	prefs:SetBool("DS_bone_time.doRot", self.doRot)
	prefs:SetBool("DS_bone_time.doPos", self.doPos)
	prefs:SetBool("DS_bone_time.doScale", self.doScale)
end


-- **************************************************
-- Recurring values
-- **************************************************

DS_bone_time.doFrame=0
DS_bone_time.lkey = 0

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_bone_time:IsEnabled(moho)
	if (moho.layer:LayerType() ~= MOHO.LT_BONE) then
		return false
	else
	

	
	
		return true
	end
	
	
	
	
	
end

function DS_bone_time:selRotated(moho)
	if (skel == nil) then
			return false
	end
	
	local currFrame = moho.frame
	
	for f = currFrame, 1, -1 do
		for b = 0, skel:CountBones() - 1 do
			if (skel:Bone(b).fAnimAngle:HasKey(f)) then
				for i = 0, skel:CountBones() - 1 do
							local bone = skel:Bone(i)
							if (bone.fAnimAngle:HasKey(f)) then
								bone.fSelected = true
							else
								bone.fSelected = false
							end
				end
			self.LastKey = f
			DS_bone_time:UpdateWidgets(moho)
			return
			end
		end
	end
end

function DS_bone_time:selTranslated(moho)
	if (skel == nil) then
			return false
	end
	
	local currFrame = moho.frame
	
	for f = currFrame, 1, -1 do
		for b = 0, skel:CountBones() - 1 do
			if (skel:Bone(b).fAnimPos:HasKey(f)) then
				for i = 0, skel:CountBones() - 1 do
							local bone = skel:Bone(i)
							if (bone.fAnimPos:HasKey(f)) then
								bone.fSelected = true
							else
								bone.fSelected = false
							end
				end
				self.LastKey = f
				DS_bone_time:UpdateWidgets(moho)
			return
			end
		end
	end
end

function DS_bone_time:selScaled(moho)
	if (skel == nil) then
			return false
	end
	
	local currFrame = moho.frame
	
	for f = currFrame, 1, -1 do
		for b = 0, skel:CountBones() - 1 do
			if (skel:Bone(b).fAnimScale:HasKey(f)) then
				for i = 0, skel:CountBones() - 1 do
							local bone = skel:Bone(i)
							if (bone.fAnimScale:HasKey(f)) then
								bone.fSelected = true
							else
								bone.fSelected = false
							end
				end
			self.LastKey = f
			DS_bone_time:UpdateWidgets(moho)
			return
			end
		end
	end
end

function DS_bone_time:OnMouseDown(moho, mouseEvent)


	if (mouseEvent.ctrlKey) then
		LM_SelectBone:OnMouseDown(moho, mouseEvent)
		return
	elseif (mouseEvent.altKey) then
		LM_SelectBone:OnMouseDown(moho, mouseEvent)
		return
	end

	local skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
	

	editFrame=self.startframeNR:Value()
	curFrame=moho.layer:CurFrame()

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

end


function DS_bone_time:OnMouseMoved(moho, mouseEvent)

	if (mouseEvent.ctrlKey) then
		LM_SelectBone:OnMouseMoved(moho, mouseEvent)
		return
	elseif (mouseEvent.altKey) then
		LM_SelectBone:OnMouseMoved(moho, mouseEvent)
		return
	end

local skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
	
	mouseGenValue=mouseEvent.pt.x-mouseEvent.startPt.x
	
	if (self.doFrame==true) then
	
		if (mouseEvent.shiftKey) then
		newFrame=editFrame+math.floor(mouseGenValue)
		else
		newFrame=editFrame+math.floor(mouseGenValue/10)
		end
		if newFrame<0 then
		newFrame=0
		end
	else
		if (mouseEvent.shiftKey) then
		newFrame=curFrame+math.floor(mouseGenValue)
		else
		newFrame=curFrame+math.floor(mouseGenValue/10)
		end
		if newFrame<0 then
		newFrame=0
		end
	end
	
	for i = 0, skel:CountBones() - 1 do
		local newPosV=LM.Vector2:new_local()
		local newRot
		local newScale
		local bone = skel:Bone(i)
		if (bone.fSelected) then
		if (self.doPos==true) then
		newPosV=bone.fAnimPos:GetValue(newFrame)
		bone.fAnimPos:SetValue(curFrame, newPosV)
		end
		if (self.doRot==true) then
		newRot=bone.fAnimAngle:GetValue(newFrame)
		bone.fAnimAngle:SetValue(curFrame, newRot)
		end
		if (self.doScale==true) then
		newScale=bone.fAnimScale:GetValue(newFrame)
		bone.fAnimScale:SetValue(curFrame, newScale)
		end
		
		
		self.frameNR:SetValue(newFrame)
		
		
			
		end
	end
	moho.layer:UpdateCurFrame()
		mouseEvent.view:DrawMe()
end



function DS_bone_time:OnMouseUp(moho, mouseEvent)

	if (mouseEvent.ctrlKey) then
		LM_SelectBone:OnMouseUp(moho, mouseEvent)
		return
	elseif (mouseEvent.altKey) then
		LM_SelectBone:OnMouseUp(moho, mouseEvent)
		return
	end

local skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
		moho:NewKeyframe(CHANNEL_BONE)
		moho:NewKeyframe(CHANNEL_BONE_S)
		moho:NewKeyframe(CHANNEL_BONE_T)
		moho:UpdateSelectedChannels()
		moho.layer:UpdateCurFrame()
end

function DS_bone_time:SetIt(moho, theValue)
local skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
	curFrame=moho.layer:CurFrame()
	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()
	for i = 0, skel:CountBones() - 1 do
		local newPosV=LM.Vector2:new_local()
		local newRot
		local newScale
		local bone = skel:Bone(i)
		if (bone.fSelected) then
		
		if (self.doPos==true) then
		newPosV=bone.fAnimPos:GetValue(theValue)
		bone.fAnimPos:SetValue(curFrame, newPosV)
		end
		if (self.doRot==true) then
		newRot=bone.fAnimAngle:GetValue(theValue)
		bone.fAnimAngle:SetValue(curFrame, newRot)
		end
		if (self.doScale==true) then
		newScale=bone.fAnimScale:GetValue(theValue)
		bone.fAnimScale:SetValue(curFrame, newScale)
		end

		end
	end
	
		moho:NewKeyframe(CHANNEL_BONE)
		moho:NewKeyframe(CHANNEL_BONE_S)
		moho:NewKeyframe(CHANNEL_BONE_T)
		moho:UpdateSelectedChannels()
		moho.layer:UpdateCurFrame()
		
end

function DS_bone_time:SelAll(moho, theValue)
local skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
	skel:SelectAll()
	
	
end
----------------------------------------------------------------Menu

DS_bone_time.SETIT = MOHO.MSG_BASE
DS_bone_time.SELALL = MOHO.MSG_BASE+1
DS_bone_time.ROT = MOHO.MSG_BASE+2
DS_bone_time.POS = MOHO.MSG_BASE+3
DS_bone_time.SCALE = MOHO.MSG_BASE+4
DS_bone_time.FRAME = MOHO.MSG_BASE+5
DS_bone_time.ROTSEL = MOHO.MSG_BASE+6
DS_bone_time.TRANSEL = MOHO.MSG_BASE+7
DS_bone_time.SCALESEL = MOHO.MSG_BASE+8

function DS_bone_time:DoLayout(moho, layout)
self.selBut= LM.GUI.Button("Select all bones", self.SELALL)
	layout:AddChild(self.selBut)
	
	self.theText=LM.GUI.StaticText("Get value from frame:")
	layout:AddChild(self.theText)
	
	self.frameNR = LM.GUI.TextControl(0, "000000", 0, LM.GUI.FIELD_INT)
	self.frameNR:SetValue(0)
	layout:AddChild(self.frameNR)
	
	self.setBut= LM.GUI.Button("Set", self.SETIT)
	layout:AddChild(self.setBut)
	
	rotBox = LM.GUI.CheckBox("Get rotation", self.ROT)
	rotBox:SetValue(DS_bone_time.doRot)
	layout:AddChild(rotBox)
	
	
	posBox = LM.GUI.CheckBox("Get position", self.POS)
	layout:AddChild(posBox)
	posBox:SetValue(DS_bone_time.doPos)
	
	scaleBox = LM.GUI.CheckBox("Get scale", self.SCALE)
	layout:AddChild(scaleBox)
	scaleBox:SetValue(DS_bone_time.doScale)
	
	frameBox = LM.GUI.CheckBox("Always start on frame:", self.FRAME)
	layout:AddChild(frameBox)
	
	self.startframeNR = LM.GUI.TextControl(0, "000000", 0, LM.GUI.FIELD_INT)
	self.startframeNR:SetValue(0)
	layout:AddChild(self.startframeNR)
	
	layout:AddChild(LM.GUI.Divider(true))
	
	layout:AddChild(LM.GUI.StaticText("Select last:"))
	
	rotselBox = LM.GUI.Button("Rotated", self.ROTSEL)
	layout:AddChild(rotselBox)
	
	transelBox = LM.GUI.Button("Translated", self.TRANSEL)
	layout:AddChild(transelBox)
	
	scaleselBox = LM.GUI.Button("Scaled", self.SCALESEL)
	layout:AddChild(scaleselBox)
	
	layout:AddChild(LM.GUI.StaticText("Last key:"))
	
	self.lkey=LM.GUI.DynamicText("000", 12)
	self.lkey:SetValue(self.LastKey)
	layout:AddChild(DS_bone_time.lkey)
	
end

function DS_bone_time:UpdateWidgets(moho)
	self.lkey:SetValue(DS_bone_time.LastKey)
end

function DS_bone_time:HandleMessage(moho, view, msg)
	skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end

	if (msg == self.SETIT) then
		DS_bone_time:SetIt(moho, self.frameNR:IntValue())
	end
	if (msg == self.SELALL) then
		DS_bone_time:SelAll(moho)
	end
	if (msg == self.ROT) then
		self.doRot=rotBox:Value()
	end
		if (msg == self.POS) then
		self.doPos=posBox:Value()
	end
		if (msg == self.SCALE) then
		self.doScale=scaleBox:Value()
	end
	if (msg == self.FRAME) then
		self.doFrame=frameBox:Value()
	end
	if (msg == self.ROTSEL) then
		DS_bone_time:selRotated(moho)
	end
	if (msg == self.TRANSEL) then
		DS_bone_time:selTranslated(moho)
	end
	if (msg == self.SCALESEL) then
		DS_bone_time:selScaled(moho)
	end

end
