-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_CycleOffsetAlt"

-- **************************************************
-- General information about this script
-- **************************************************

DS_CycleOffsetAlt = {}
function DS_CycleOffsetAlt:Name()
	return "DS_CycleOffsetAlt"
end

function DS_CycleOffsetAlt:Version()
	return "0.3"
end

function DS_CycleOffsetAlt:Description()
	return "Offset a cycle to move a walkcycle"
end

function DS_CycleOffsetAlt:Creator()
	return "dauid.com"
end

function DS_CycleOffsetAlt:UILabel()
	return("DS Cycle Offset Alternate")
end
-- **************************************************
-- Recurring values
-- **************************************************
DS_CycleOffsetAlt.doLayer = false 
DS_CycleOffsetAlt.doBone = true
DS_CycleOffsetAlt.LoopTimes = 10
DS_CycleOffsetAlt.StartLoop = 0
DS_CycleOffsetAlt.EndLoop = 0
DS_CycleOffsetAlt.lockFix = false

--************************menu
local DS_Dialog = {}

DS_Dialog.UPDATE = MOHO.MSG_BASE

function DS_Dialog:new(moho)

	DS_CycleOffsetAlt.StartLoop = moho.document:StartFrame()
	DS_CycleOffsetAlt.EndLoop = moho.document:EndFrame()

	local d = LM.GUI.SimpleDialog("Settings", DS_Dialog)
	local l = d:GetLayout()
	
	d.moho = moho
	
	l:PushH()
		l:PushV()
			l:AddChild(LM.GUI.StaticText("Start frame of loop: "))
			l:AddChild(LM.GUI.StaticText("End frame of loop: "))
			l:AddChild(LM.GUI.StaticText("Loop this many times: "))
		l:Pop()
		l:PushV()
			d.startLoop = LM.GUI.TextControl(0, "0.0000", DS_Dialog.UPDATE, LM.GUI.FIELD_INT)
			d.startLoop:SetValue(DS_CycleOffsetAlt.StartLoop)
			l:AddChild(d.startLoop)

			d.endLoop = LM.GUI.TextControl(0, "0.0000", DS_Dialog.UPDATE, LM.GUI.FIELD_INT)
			d.endLoop:SetValue(DS_CycleOffsetAlt.EndLoop)
			l:AddChild(d.endLoop)
			
			d.loopTimes = LM.GUI.TextControl(0, "0.0000", DS_Dialog.UPDATE, LM.GUI.FIELD_UINT)
			l:AddChild(d.loopTimes)
		l:Pop()
	l:Pop()

	boneBox = LM.GUI.RadioButton("Cycle selected bones position")
	l:AddChild(boneBox, LM.GUI.ALIGN_LEFT)


	layerBox = LM.GUI.RadioButton("Cycle selected layer position")
	l:AddChild(layerBox, LM.GUI.ALIGN_LEFT)
	
	
	fixBox = LM.GUI.CheckBox("Fix locked bones")
	l:AddChild(fixBox, LM.GUI.ALIGN_LEFT)
	fixBox:SetValue(DS_CycleOffsetAlt.lockFix)
	l:AddChild(LM.GUI.Divider(false), LM.GUI.ALIGN_FILL) 
	l:PushV()
	l:AddChild(LM.GUI.StaticText("Note: Script will take much longer to run with Fix Locked Bones enabled."))
	l:AddChild(LM.GUI.StaticText("Be patient."))
	return d
end

function DS_Dialog:UpdateWidgets()
	self.loopTimes:SetValue(DS_CycleOffsetAlt.LoopTimes)
	
	if (self.moho.layer:LayerType() ~= MOHO.LT_BONE) then
		boneBox:Enable(false)
		fixBox:Enable(false)
		layerBox:SetValue(true)
	else
		boneBox:Enable(true)
		fixBox:Enable(true)
		layerBox:SetValue(false)
		boneBox:SetValue(true)
	end
end


function DS_Dialog:OnOK()
DS_CycleOffsetAlt.lockFix=fixBox:Value()
DS_CycleOffsetAlt.doBone=boneBox:Value()
DS_CycleOffsetAlt.doLayer=layerBox:Value()
DS_CycleOffsetAlt.LoopTimes = self.loopTimes:Value()
DS_CycleOffsetAlt.EndLoop = self.endLoop:Value()
DS_CycleOffsetAlt.StartLoop = self.startLoop:Value()
end

-- **************************************************
-- The guts of this script
-- **************************************************


function DS_CycleOffsetAlt:Run(moho)
local originFrame = moho.frame
local endFrame = moho.document:EndFrame()
local theBone = -1
local Interpolation = 0
local AbsoluteCycle = 0
local RelativeCycle = 0
local duration = 0
local layer = moho.layer
local CycleToThis = self.StartLoop
local v1 = LM.Vector2:new_local()
local v2 = LM.Vector2:new_local()
local v3 = LM.Vector2:new_local()
local v4 = LM.Vector2:new_local()
local v5 = LM.Vector2:new_local()
local Interp = -1
local val1 = -1
local val2 = -1
local ch = nil

local dlog = DS_Dialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end

	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()

if (self.doBone) then -- here be bone mode
		if (skel == nil) then
				return false
		end

		local skel = moho:Skeleton()
		
		for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			if (theBone.fSelected) then 
			break
			end
		end
	
	ch = theBone.fAnimPos
	local v1 = LM.Vector2:new_local()
	local v2 = LM.Vector2:new_local()
	local v3 = LM.Vector2:new_local()
	local v4 = LM.Vector2:new_local()
	local v5 = LM.Vector2:new_local()
else
	ch = layer.fTranslation
	local v1 = LM.Vector3:new_local()
	local v2 = LM.Vector3:new_local()
	local v3 = LM.Vector3:new_local()
	local v4 = LM.Vector3:new_local()
	local v5 = LM.Vector3:new_local()
end
		
		
		local FrameAmount = self.EndLoop - self.StartLoop
		endFrame = (self.EndLoop+1)+(self.LoopTimes*FrameAmount)

		for f = self.EndLoop+1, endFrame do
			local loopCount = math.ceil((f-self.StartLoop)/FrameAmount)
			local subtractAmount = FrameAmount * (loopCount-1)
			if (ch:HasKey(f-subtractAmount)) then
				--First we set the correct value
				v1 = ch:GetValue(f-subtractAmount) -- Get position from the loop
				v2 = ch:GetValue(self.EndLoop) -- Get position from the end of the loop
				v3 = ch:GetValue(self.StartLoop)
				v4 = (v2 - v3) * (loopCount-1)
				v5 = v1 + v4
				ch:SetValue(f, v5)
				--Then we set the correct interpolation
				if (ch.GetKeyInterpMode ~= nil) then
				Interp, val1, val2 = ch:GetKeyInterp(f-subtractAmount, Interp,val1, val2);
				end
				ch:SetKeyInterp(f, Interp, val1, val2)
			end
			------Do the rest of the bones ---------
			if (self.doBone) then
				for tempBone = 0, skel:CountBones() - 1 do --For every bone do this
				local theTempBone=skel:Bone(tempBone)
					if not(theTempBone.fSelected) then
						if (theTempBone.fAnimPos:HasKey(f-subtractAmount)) then
							theTempBone.fAnimPos:SetValue(f, (theTempBone.fAnimPos:GetValue(f-subtractAmount)))
							
						end
					end
						if (theTempBone.fAnimAngle:HasKey(f-subtractAmount)) then
							theTempBone.fAnimAngle:SetValue(f, (theTempBone.fAnimAngle:GetValue(f-subtractAmount)))
							
						end
						if (theTempBone.fAnimScale:HasKey(f-subtractAmount)) then
							theTempBone.fAnimScale:SetValue(f, (theTempBone.fAnimScale:GetValue(f-subtractAmount)))
							
						end
						
						if (theTempBone.fIKLock:HasKey(f-subtractAmount)) then 
							theTempBone.fIKLock:SetValue(f, (theTempBone.fIKLock:GetValue(f-subtractAmount)))
						end
					
					--skel:UpdateBoneMatrix(tempBone)
				end
			end
		end
		--------------------------------------
			--Lockfix. Don't know why this is necessary but it seems to be.
			-- Basically we toggle every damn locked keyframe while going back and forth in the timeline.
			if (self.doBone and self.lockFix) then
				for f = self.EndLoop+1, endFrame do
				moho:SetCurFrame(f)
						for i = 0, skel:CountBones() - 1 do --For every bone do this
							local theTempBone=skel:Bone(i)
							if (theTempBone.fIKLock:HasKey(f)) then 
								if (theTempBone.fIKLock.value) then
									skel:UnlockBone(i, f)
									moho:SetCurFrame(f-1)
									moho:SetCurFrame(f)
									skel:LockBone(i, f)
								else
									skel:LockBone(i, f)
									moho:SetCurFrame(f-1)
									moho:SetCurFrame(f)
									skel:UnlockBone(i, f)
								end
							end
						end
						
				end
			end
			------------------------------------
			moho:SetCurFrame(originFrame)
	moho.layer:UpdateCurFrame(true)
end