
-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_layertoae"

-- **************************************************
-- General information about this script
-- **************************************************

DS_layertoae = {}
function DS_layertoae:Name()
	return "DS Layer to AE"
end

function DS_layertoae:Version()
	return "0.3"
end

function DS_layertoae:Description()
	return "Export layer animation to After Effects"
end

function DS_layertoae:Creator()
	return "dauid.com"
end

function DS_layertoae:UILabel()
	return("DS Layer to AE")
end


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_layertoae:Run(moho)

local path = LM.GUI.SaveFile("Select Data File")
	if (path == "") then
		return
	end
	
		local f = io.open(path..".txt", "w")

	if (f == nil) then
		return
	end

local width = moho.document:Width()
local height = moho.document:Height()
local aspect = moho.document:AspectRatio()
local newX = (moho.document:Width()/2)
local newY = moho.document:Height()/2
local newZ = moho.document:Height()/2
local fps = moho.document:Fps()
local startframe = moho.document:StartFrame()
local endframe = moho.document:EndFrame()
local anchor= LM.Vector2:new_local()
local translation= LM.Vector3:new_local()
local layer =moho.layer
local scale= LM.Vector3:new_local()

if (layer:LayerType()==MOHO.LT_IMAGE) then

layer = moho:LayerAsImage(layer)
 pixelX=layer:PixelWidth()
 pixelY=layer:PixelHeight()
end

f:write("Adobe After Effects 8.0 Keyframe Data\n")
f:write("\n\tUnits Per Second\t"..fps)
f:write("\n\tSource Width\t"..width)
f:write("\n\tSource Height\t"..height)
f:write("\n\tSource Pixel Aspect Ratio\t1")
f:write("\n\tComp Pixel Aspect Ratio\t1\n")

--Anchor point
f:write("\nTransform\tAnchor Point\n")
f:write("\tFrame\tX pixels\tY pixels\tZ pixels\n")
	anchor = layer:Origin()
	
if (layer:LayerType()==MOHO.LT_IMAGE) then
	if (aspect >0) then
		anchor.x = ((anchor.x + 1) * newY)+(newX-newY) -(newX-(pixelX/2))
		anchor.y = (((anchor.y*(-1)) + 1) * newY)-(newY-(pixelY/2))
	else
		anchor.x = ((anchor.x + 1) * newX) -(newX-(pixelX/2))
		anchor.y = ((anchor.y*(-1)) + 1) * newX + (newY-newX)-(newY-(pixelY/2))
	end
	f:write("\t".. startframe .."\t".. anchor.x .."\t".. anchor.y .."\t".. "0" .."\n")
else
	if (aspect >0) then
		anchor.x = ((anchor.x + 1) * newY)+(newX-newY)
		anchor.y = ((anchor.y*(-1)) + 1) * newY
	else
		anchor.x = ((anchor.x + 1) * newX)
		anchor.y = ((anchor.y*(-1)) + 1) * newX + (newY-newX)
	end
	f:write("\t".. startframe .."\t".. anchor.x.."\t".. anchor.y .."\t".. "0" .."\n")
end

--Position
f:write("\nTransform\tPosition\n")
f:write("\tFrame\tX pixels\tY pixels\tZ pixels\n")
	anchor = layer:Origin()
	for i = startframe, endframe do
	translation = layer.fTranslation:GetValue(i)
	if (aspect >0) then
		translation.x = (((translation.x+anchor.x) + 1) * newY)+(newX-newY)
		translation.y = (((translation.y+anchor.y)*(-1)) + 1) * newY
		translation.z = ((translation.z*(-1))*newZ)
	else
		translation.x = (((translation.x+anchor.x) + 1) * newX)
		translation.y = (((translation.y+anchor.y)*(-1)) + 1) * newX + (newY-newX)
		translation.z = ((translation.z*(-1))*newX)
	end
	f:write("\t".. i .."\t".. translation.x.."\t".. translation.y .."\t".. translation.z .."\n")
	end 
	--scale
f:write("\nTransform\tScale\n")
f:write("\tFrame\tX percent\tY percent\tZ percent\n")
	for i = startframe, endframe do
	scale = layer.fScale:GetValue(i)
	f:write("\t".. i .."\t".. scale.x*100 .."\t".. scale.y*100 .."\t".. scale.z*100 .."\n")
	end 
--Rotation
f:write("\nTransform\tRotation\n")
f:write("\tFrame\tdegrees\n")
	for i = startframe, endframe do
	local rotation = math.deg(layer.fRotationZ:GetValue(i))
	f:write("\t".. i .."\t".. rotation*(-1) .."\n")
	end 
--X rotation
f:write("\nTransform\tX Rotation\n")
f:write("\tFrame\tdegrees\n")
	for i = startframe, endframe do
	local xrot = layer.fRotationX:GetValue(i)
	f:write("\t".. i .."\t".. math.deg(xrot) .."\n")
	end 
--Y rotation
f:write("\nTransform\tY Rotation\n")
f:write("\tFrame\tdegrees\n")
	for i = startframe, endframe do
	local yrot = layer.fRotationY:GetValue(i)
	f:write("\t".. i .."\t".. (math.deg(yrot))*(-1) .."\n")
	end 
--Opacity
f:write("\nTransform\tOpacity\n")
f:write("\tFrame\tpercent\n")
	for i = startframe, endframe do
		if (layer.fVisibility:GetValue(i)==false) then
		f:write("\t".. i .."\t".. 0 .."\n")
		else
		local opacity = layer.fAlpha:GetValue(i)
		f:write("\t".. i .."\t".. opacity*100 .."\n")
		end
	end 
f:write("\n\nEnd of Keyframe Data")
f:close() --Close the file
end