

-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_LoadMorph"

-- **************************************************
-- General information about this script
-- **************************************************

DS_LoadMorph = {}

function DS_LoadMorph:Name()
	return "Load morph"
end

function DS_LoadMorph:Version()
	return "0.1"
end

function DS_LoadMorph:Description()
	return "Load morph"
end

function DS_LoadMorph:Creator()
	return "dauid.com"
end

function DS_LoadMorph:UILabel()
	return("Load morph")
end

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_LoadMorph:Run(moho)

local path = LM.GUI.OpenFile("Select an image")
	if (path == "") then
		return
	end

	path = string.reverse(path)
	local sepPos = string.find(path, "/")
	if (sepPos == nil) then
		sepPos = string.find(path, "\\")
	end
	if (sepPos == nil) then
		return
	end

	local scanDir = string.sub(path, sepPos + 1)
	scanDir = string.reverse(scanDir)
	
	moho:BeginFileListing(scanDir)
	local fileName = moho:GetNextFile()
	local theFile
	
	local slayer = moho:LayerAsSwitch(moho:CreateNewLayer(MOHO.LT_SWITCH))
	slayer:SetName(fileName)
	
	local skel = moho:Skeleton()
	if (skel == nil) then
		return
	end
	
	local bone=skel:AddBone(0)
	bone.fAnimAngle:SetValue(0, 0)
	bone.fConstraints = true
	bone.fMinConstraint =0
	bone.fMaxConstraint = math.pi*2
	bone.fStrength = 0
	bone:SetName("SwitchControl")
	
	
	local i = 1
	
	while fileName ~= nil do
		theFile = scanDir .. "\\" .. fileName
		--print(fileName)
		
		local image = moho:LayerAsImage(moho:CreateNewLayer(MOHO.LT_IMAGE))
		moho:PlaceLayerInGroup(image, moho:LayerAsGroup(slayer), true)
		image:SetName(i)
		i = i+1
		image:SetSourceImage(theFile)
		fileName = moho:GetNextFile()
	end
	slayer:SwitchValues():SetValue(0, "1")
	slayer:Expand(false)
	moho:SetSelLayer(slayer)
end
