

-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_SaveBoneAnim"

-- **************************************************
-- General information about this script
-- **************************************************

DS_SaveBoneAnim = {}

function DS_SaveBoneAnim:Name()
	return "Save bone animation"
end

function DS_SaveBoneAnim:Version()
	return "0.5"
end

function DS_SaveBoneAnim:Description()
	return "Save bone animation"
end

function DS_SaveBoneAnim:Creator()
	return "dauid.com"
end

function DS_SaveBoneAnim:UILabel()
	return("Save bone animation")
end

--************************menu
local DS_Dialog = {}

DS_Dialog.UPDATE = MOHO.MSG_BASE

function DS_Dialog:new(moho)
	local d = LM.GUI.SimpleDialog("Settings", DS_Dialog)
	local l = d:GetLayout()

	d.moho = moho


	angleBox = LM.GUI.CheckBox("Export bone angles")
	l:AddChild(angleBox, LM.GUI.ALIGN_LEFT)	
	angleBox:SetValue(true)
	posBox = LM.GUI.CheckBox("Export bone positions")
	l:AddChild(posBox, LM.GUI.ALIGN_LEFT)	
	posBox:SetValue(true)
	
	scaleBox = LM.GUI.CheckBox("Export scale")
	l:AddChild(scaleBox, LM.GUI.ALIGN_LEFT)	
	scaleBox:SetValue(true)
	
	lockBox = LM.GUI.CheckBox("Export locked frames")
	l:AddChild(lockBox, LM.GUI.ALIGN_LEFT)	
	lockBox:SetValue(true)




	return d
end


function DS_Dialog:HandleMessage(what)

end

function DS_Dialog:OnOK()
angleBox=angleBox:Value()
posBox=posBox:Value()
lockBox=lockBox:Value()
scaleBox=scaleBox:Value()

end


-- **************************************************
-- The guts of this script
-- **************************************************


function DS_SaveBoneAnim:IsEnabled(moho)

	if (moho.layer:LayerType() ~= MOHO.LT_BONE) then --If a bone layer is not selected, disable the script
		return false
	end
skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end
	--if (moho.layer:CurrentAction() ~= "") then
		--return false -- creating new objects in the middle of an action can lead to unexpected results
	--end
	return true
end


function DS_SaveBoneAnim:Run(moho)

local dlog = DS_Dialog:new(moho)
	if (dlog:DoModal() == LM.GUI.MSG_CANCEL) then
		return
	end


local path = LM.GUI.SaveFile("Select Data File")
	if (path == "") then
		return
	end

	local f = io.open(path, "w")
	if (f == nil) then
		return
	end
	
startFrame = moho.document:StartFrame()
endFrame = moho.document:EndFrame()

	
		for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			theBoneName=theBone:Name()
			
			if (theBoneName ~= "") then --If the bone has a name, do the following
			f:write("Bone: \n")
			f:write(theBoneName.."\n") --Write the bone name to file
			
			FrameTable={} --create a table to hold frames
			ValueTable={} --create a table to hold values
			
			--------------------------------------- Store values for angle vvv
			if (angleBox==true) then
				for frames=startFrame, endFrame do --Go through every frame
					local bajs=theBone.fAnimAngle 
					if (bajs:HasKey(frames)) then --If there is a keyframe for the angle then...
					table.insert(FrameTable, frames) --Insert the frame numbers with keys into this table (a.k.a array)
					table.insert(ValueTable, theBone.fAnimAngle:GetValue(frames)) --Insert the value into this other table
					end
				end
				f:write(# FrameTable.."\n") --Write to file how many keys there are so we know how many to import when loading animation
				for i,v in ipairs(FrameTable) do --Go through every value in frame table
				f:write(v.." "..ValueTable[i].."\n") --Write the frame number and the corresponding value from the value table
				end
			else
			f:write("0\n")
			end

			--------------------------------------- Store values for position vvv
			
			FrameTable={} --empty the table so we can use it again
			Value1Table={} --Table for x value
			Value2Table={} -- Table for y value
			local vec=LM.Vector2:new_local() --The position will be returned as a vector, create a variable to hold it
			if (posBox==true) then
				for frames=startFrame, endFrame do --Go through every frame
					local bajs=theBone.fAnimPos 
					if (bajs:HasKey(frames)) then --If there is a keyframe for the angle then...
					table.insert(FrameTable, frames) --Insert the frame numbers with keys into this table (a.k.a array)
					vec=theBone.fAnimPos:GetValue(frames) --Get the vector
					table.insert(Value1Table, vec.x) --Insert the x value into value1 table
					table.insert(Value2Table, vec.y) --Insert the y value into value2 table
					end
				end
				f:write(# FrameTable.."\n") --Write to file how many keys there are so we know how many to import when loading animation

					for i,v in ipairs(FrameTable) do --Go through every value in frame table
					f:write(v.." "..Value1Table[i].." "..Value2Table[i].."\n") --Write the frame number and the corresponding value from the value table
					end
			else
			f:write("0\n")
			end
				
			--------------------------------------------------- Store values for locked bones
			FrameTable={} --empty the table so we can use it again
			ValueTable={} --empty the table so we can use it again
			if (lockBox==true) then
				for frames=startFrame, endFrame do --Go through every frame
					local bajs=theBone.fIKLock 
					if (bajs:HasKey(frames)) then --If there is a keyframe for the bone lock then...
					table.insert(FrameTable, frames) --Insert the frame numbers with keys into this table (a.k.a array)
					table.insert(ValueTable, theBone.fIKLock:GetValue(frames)) --Insert the value into this other table
					end
				end
				f:write(# FrameTable.."\n") --Write to file how many keys there are so we know how many to import when loading animation
				for i,v in ipairs(FrameTable) do --Go through every value in frame table
					if (ValueTable[i]==true) then --If bone is locked..
					f:write(v.." 1\n") --write 1
					else				--otherwise..
					f:write(v.." 0\n") 	--Write 0
					end
				end
				else
				f:write("0\n") --If there are no keys just write 0
				end
			end
			--------------------------------------- Store values for scale vvv
			FrameTable={} --empty the table so we can use it again
			ValueTable={} --empty the table so we can use it again
			if (scaleBox==true) then
				for frames=startFrame, endFrame do --Go through every frame
					local bajs=theBone.fAnimScale 
					if (bajs:HasKey(frames)) then --If there is a keyframe for the scale then...
					table.insert(FrameTable, frames) --Insert the frame numbers with keys into this table (a.k.a array)
					table.insert(ValueTable, theBone.fAnimScale:GetValue(frames)) --Insert the value into this other table
					end
				end
				f:write(# FrameTable.."\n") --Write to file how many keys there are so we know how many to import when loading animation
				for i,v in ipairs(FrameTable) do --Go through every value in frame table
				f:write(v.." "..ValueTable[i].."\n") --Write the frame number and the corresponding value from the value table
				end
			else
			f:write("0\n")
			end
			
			
		end

	
	f:close() --Close the file

end
